package appmain;
/**
* This servlet is a display tool for showing elements of a servlet's context.
* 
* <p>$Id: Contexter.java,v 1.1 2003/04/07 16:18:07 finson Exp $
*/
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
/**
* Simple servlet to show various elements of the servlet context.
*/
public final class Contexter extends HttpServlet {
	/**
	* Initialize the servlet data values.
	*/
	public void init() {
		ServletConfig config = getServletConfig();
		params = new HashMap();
		Enumeration ip = config.getInitParameterNames();
		while (ip.hasMoreElements()) {
			String pN = (String)ip.nextElement();
			String pV = config.getInitParameter(pN);
			params.put(pN,pV);
		}
	}
	/**
	* Respond to a GET request for the content produced by
	* this servlet.
	*
	* @param request The servlet request we are processing
	* @param response The servlet response we are producing
	*
	* @exception IOException if an input/output error occurs
	* @exception ServletException if a servlet error occurs
	*/
	public void doGet(HttpServletRequest request,HttpServletResponse response)
	throws IOException, ServletException {
		Enumeration names;
		response.setContentType("text/html");
		PrintWriter writer = response.getWriter();
		
		writer.println("<html>");
		writer.println("<head>");
		writer.println("<title>Contexter - Tell it like it is</title>");
		writer.println("</head>");
		
		writer.println("<p><b>Contexter - Tell it like it is</b></p>");
		writer.println("<p>Display various items of information about the servlet context.</p>");
		
		//  Context attributes
		
		ServletContext context = this.getServletContext();
		writer.println("<table border=\"0\" width=\"100%\">");
		writer.println("<tr><th align=\"right\">Attribute Name:</th><th  align=\"left\">Attribute Value</th></tr>");
		names = context.getAttributeNames();
		while (names.hasMoreElements()) {
			String name = (String) names.nextElement();
			writer.println("<tr>");
			writer.println("  <th align=\"right\">" + name + ":</th>");
			writer.println("  <td>" + context.getAttribute(name) + "</td>");
			writer.println("</tr>");
		}
		writer.println("</table>");
		
		// Init Parameters
		
		writer.println("<br><br>");
		writer.println("<table border=\"0\" width=\"100%\">");
		writer.println("<tr><th align=\"right\">Init Parameter Name:</th><th align=\"left\">Init Parameter Value</th></tr>");
		for (Iterator iter=params.entrySet().iterator(); iter.hasNext(); ) {
			Map.Entry e = (Map.Entry) iter.next();
			writer.println("<tr>");
			writer.println("  <th align=\"right\">" + e.getKey() + ":</th>");
			writer.println("  <td>" + e.getValue() + "</td>");
			writer.println("</tr>");
		}
		writer.println("</table>");
		
		// request Header entries
		
		writer.println("<br><br>");
		writer.println("<table border=\"0\" width=\"100%\">");
		writer.println("<tr><th align=\"right\">Header Name:</th><th align=\"left\">Header Value</th></tr>");
		names = request.getHeaderNames();
		while (names.hasMoreElements()) {
			String name = (String) names.nextElement();
			writer.println("<tr>");
			writer.println("  <th align=\"right\">" + name + ":</th>");
			writer.println("  <td>" + request.getHeader(name) + "</td>");
			writer.println("</tr>");
		}
		writer.println("</table>");
		
		
		writer.println("</body>");
		writer.println("</html>");
	}
	
	//-----------------------------------------------------------------------
	
	/** Store the Init Parameters */
	HashMap params;
}
